'use strict';

var DebitoPeriodoController = angular.module('DebitoPeriodoController', []);

DebitoPeriodoController.controller('DebitoPeriodoCtrl', ['$scope', '$filter', 'Relatorio', 'CacheApp',
  ($scope, $filter, Relatorio, CacheApp) => {

    $scope.construcao = CacheApp.getConstrucao();
    $scope.assinatura = true;
    $scope.descricaoObra = true;

    $scope.relatorio = {};
    $scope.relatorio.DataInicio = CacheApp.getData($scope.construcao.DataInicio ? $filter("date")($scope.construcao.DataInicio, 'yyyy-MM-ddT00:00:00Z') : $filter("date")(Date.now(), 'yyyy-MM-ddT00:00:00Z'));
    $scope.relatorio.DataFim = CacheApp.getData($scope.construcao.DataFim ? $filter("date")($scope.construcao.DataFim, 'yyyy-MM-ddT00:00:00Z') : $filter("date")(Date.now(), 'yyyy-MM-ddT00:00:00Z'));

    $scope.ListaTipo = [
        {Id: 17, Descricao: 'A Pagar'},
        {Id: 39, Descricao: 'Pagas'}
    ];
    $scope.TipoSelecionada = {Id: 17, Descricao: 'A Pagar'};

    $scope.getRelatorioDebitoPeriodo = () => {
        $scope.DebitoPeriodo = {};
        Relatorio.getRelatorioDebitoPeriodo($scope.construcao.Id, $filter("date")($scope.relatorio.DataInicio, 'yyyy-MM-dd'), $filter("date")($scope.relatorio.DataFim, 'yyyy-MM-dd'), $scope.TipoSelecionada.Id,
            (data) => {
                $scope.DebitoPeriodo = data.Instance;
            });
    }
    $scope.getRelatorioDebitoPeriodo();

    $scope.pdfDebitoPeriodo = () => {
        var cabecalho = {
            Avatar: $scope.construcao.ContaAvatar,
            Obra: $scope.construcao.Titulo,
            Conta: $scope.construcao.Conta,
            DataInicio: $filter("date")($scope.relatorio.DataInicio, 'dd/MM/yyyy'),
            DataFim: $filter("date")($scope.relatorio.DataFim, 'dd/MM/yyyy'),
            Moeda: $scope.construcao.Moeda
        };

        if ($scope.assinatura == true) {
            cabecalho.Responsavel = $scope.construcao.Contato
        };
        if ($scope.descricaoObra == true) {
            cabecalho.DescricaoObra = $scope.construcao.Descricao
        };

        Relatorio.pdfRelatorioDebitoPeriodo($scope.construcao.Id, $filter("date")($scope.relatorio.DataInicio, 'yyyy-MM-dd'), $filter("date")($scope.relatorio.DataFim, 'yyyy-MM-dd'), $scope.TipoSelecionada.Id, cabecalho,
            (data) => {
                window.location.assign(data.Instance);
            });
    }

    $scope.xlsDebitoPeriodo = () => {
    var cabecalho = {
        Avatar: $scope.construcao.ContaAvatar,
        Obra: $scope.construcao.Titulo,
        Conta: $scope.construcao.Conta,
        DataInicio: $filter("date")($scope.relatorio.DataInicio, 'dd/MM/yyyy'),
        DataFim: $filter("date")($scope.relatorio.DataFim, 'dd/MM/yyyy'),
        Moeda: $scope.construcao.Moeda
    };

    Relatorio.xlsRelatorioDebitoPeriodo($scope.construcao.Id, $filter("date")($scope.relatorio.DataInicio, 'yyyy-MM-dd'), $filter("date")($scope.relatorio.DataFim, 'yyyy-MM-dd'), $scope.TipoSelecionada.Id, cabecalho,
        (data) => {
            window.location.assign(data.Instance);
        });
    }
}]);
